# Deep Learning in Finance
Documentation for MQP 2018 completed by Everett Harding with ZHAW
Advisors: Prof. Randy Paffenroth, Prof. Stephan Strum

This project implements a Generative Adversarial Network (GAN) to solve the 
minority representation problem for trading data when attempting to detect 
illegal insider trading.

##Structure
The project is divided into two parts, the classifier and the GAN.
 
###Classifier
At the classifier level, there is no need to be aware of the GAN, so 
the only concern become the structure of the dataset. This makes the classifier
independent of the GAN, so many classifiers can be implemented and compared 
to determine the classifier with the best performance. 

###GAN
The GAN is trained using only the examples from the original dataset labeled as
"abnormal trading", indicating a deviation from a traders normal activity that could
be an instance of illegal insider trading. After training, the generator of the
GAN, G* is used to generate a number of extra samples to augment the original dataset.
The augmented set is then passed to the classifier to compare performance.