# starting out with the first trial. Using file ACF11.txt for testing.

from pandas import read_csv
from pandas import datetime
from matplotlib import pyplot


# parsing the dates for the lstm.
def parse(date):
    return datetime.strptime(date, '%m/%d/%Y %H:%M')


dataset = read_csv(
    "/home/tachanka/harddrive/ZHAW/1min_bidask/1min_bidask/ACF11.txt",
    index_col=0,
    parse_dates={'datetime': [0, 1]},
    date_parser=parse)

# manually specify column names
dataset.columns = ['1', '2', '3', '4', '5', '6', '7', '8']
values = dataset.values
groups = [0, 1, 2, 3, 5, 6, 7]
i = 1
pyplot.figure()
for group in groups:
    pyplot.subplot(len(groups), 1, i)
    pyplot.plot(values[:, group])
    pyplot.title(dataset.columns[group], y=0.5, loc='right')
    i += 1
pyplot.show()
