# import tensorflow as tf
import pandas as pd
import numpy as np
import random
""" PARAMETERS """
input_shape = 784
output_shape = 10
min_predictors = 2  # minimum number of predictors used.
y_name = 'Y'  # name of the column we wish to predict.
num_nn = 100  # how many neural networks we want to generate
file_address = "/home/tachanka/harddrive/ZHAW/practice/credit_card_default.xls"
""" PARAMETERS """


def random_pred_and_target(num_pred, predictors):
    """generates the random subset of predictors and its random target.
        @params
        num_pred: int, random number of predictors used.
        predictors: nparray, the predictors minus the target y.
        @return
        tuple of nparray of predictors and the target(extra pred) name
    """
    random_target = random.randint(0, num_pred)
    target = predictors[random_target]
    predictors = np.delete(predictors, predictors.index(random_target))
    sub_pred = []
    for i in range(num_pred):
        random_int = random.randint(0, num_pred - 1)
        random_pred = predictors[random_int]
        sub_pred.append(random_pred)

    return (sub_pred, target)


def data_handling():
    """method in charge obtaining the data,
     choosing random subsets of predictors,
     and the random target for generating the FFNNs.
    """

    # dataset
    df = pd.read_excel(file_address)
    y = df[y_name]
    columns = df.columns.values
    predictors = np.delete(columns, columns.index(y_name))
    num_predictors = len(predictors)

    all_subsets = []
    for i in range(num_nn):
        rand_num_pred = random.randint(min_predictors, num_predictors)
        preds_with_target = random_pred_and_target(rand_num_pred, predictors)
        all_subsets.append(preds_with_target)

    return (y, all_subsets)
