from tensorflow.examples.tutorials.mnist import input_data
import tensorflow as tf

mnist = input_data.read_data_sets('MNIST_data', one_hot=True)
sess = tf.InteractiveSession()

x = tf.placeholder(tf.float32, shape=[None, 784])
y_ = tf.placeholder(tf.float32, shape=[None, 10])
W = tf.Variable(tf.zeros([784, 10]))
b = tf.Variable(tf.zeros([10]))

sess.run(tf.global_variables_initializer())

# define our prediction model.
y = tf.matmul(x, W) + b

# Define our training loss function. Measure how good our model was.
cross_entropy = tf.reduce_mean(
    tf.nn.softmax_cross_entropy_with_logits(labels=y_, logits=y))

# apply gradient descent when training. Update params.
train_step = tf.train.GradientDescentOptimizer(0.5).minimize(cross_entropy)

for _ in range(1000):
    # Load 100 training examples.
    batch = mnist.train.next_batch(100)
    # run train step.
    # replace placeholder variables for actual datapoints.
    # train the model using the input data.
    train_step.run(feed_dict={x: batch[0], y_: batch[1]})

# evaluate our model. check if ground truth equals our predictions
correct_prediction = tf.equal(tf.argmax(y, 1), tf.argmax(y_, 1))

# list of 1s and 0s. Take the average of all of them.
accuracy = tf.reduce_mean(tf.cast(correct_prediction, tf.float32))

print(accuracy.eval(feed_dict={x: mnist.test.images, y_: mnist.test.labels}))
