#!/bin/env python3
#SBATCH -p short
#SBATCH -C V100
#SBATCH --gres=gpu:2
#SBATCH -J Basin-Hopper-200-Multi

# optimizer.py
# Author:       Luke Buquicchio

# Date Created: 1/30/18
# Description: An optimizer for our ensemble.

import numpy as np
import sys
sys.path.append('../')
from Legacy.model_tester import optimizable_main
from Utilities import ensemble_utils
from Utilities import data_utils


x, y = data_utils.load_uci_set()
x = data_utils.normalize(x)
x_train, x_test, y_train, y_test = data_utils.split_data(x, y, .2)
ensemble = ensemble_utils.generate_ff_ensemble(x_train, num_nets=50)

x0 = np.array([ensemble, 200, 50, 15])      # An initial guess at the optimizing argument

res = optimizable_main(x0)
# res = optimize.minimize(optimizable_main, x0, options={'disp': True})
print("Finished adapter training & eval. Accuracy is: ", res, flush=True)
