# training_combos_generator
# Author:       Everett Harding
# Date Created: 1/29/18
# Description: 
# TODO:

import numpy as np
# e_sizes = [50,100,200,500,1000]
num_hidden = [1,2,3,4]
layer_dims = [5,10,25,100,250,500]
activations = ["relu", "sigmoid"]
inits = ["uniform", "normal", "logistic"]
n_gpus = [1,2,3,4]
n_epochs = [10, 25, 50]

filename = "adapter_combinations.txt"


def build_dims(num, curr_combo, lod):
    if num == 1:
        lod.append(curr_combo)
    else:
        for d in layer_dims:
            build_dims(num - 1, curr_combo + [d], lod)


def get_all_combos():
    combos_list = []
    with open(filename,mode='w') as file:
        for activation in activations:
            for init in inits:
                # for every size available
                for num in num_hidden:
                    # for every number of hidden layers available, pick a dimension
                    dims = []
                    build_dims(num, [], dims)
                    for row in dims:
                        combo = {'activation': activation, 'init': init, 'layer_units': row}
                        combos_list.append(combo)
                        param_str = "python ../model_tester.py --adapter_activation " + activation
                        param_str += " --adapter_initialization " + init
                        param_str += " --adapter_layers "
                        for val in row:
                            param_str += str(val) + " "
                        print(param_str, file=file)


    return combos_list

