#!/bin/env python3
#SBATCH -N 2
#SBATCH -n 4
#SBATCH -o results.csv
#SBATCH --mem=16G
#SBATCH -p long
#SBATCH -C K20
#SBATCH -t 168:00:00
#SBATCH --gres=gpu:6


# batch_cross_validator
# Author:       Juan Luis Herrero
# Date Created: 1/29/18
# Description: This file will take all of the outputs of training_combos_generator
# and evaluate them to determine the optimal running conditions.
# TODO:

import subprocess
import os

os.chmod('/Users/admin/Documents/GitHub/MQP-ZHAW/model_tester.py', 0o755)
with open('/Users/admin/Documents/GitHub/MQP-ZHAW/CrossValidation/adapter_combinations.txt') as f:
    scripts = f.readlines()

iteration = 0
running_processes = []

for script in scripts:
    iteration += 1
    proc = None
    script.rstrip('\n')
    args = script.split()

    if len(running_processes) > 50:
        os.wait()

    if len(args) == 3:
        proc = subprocess.Popen(["python3", "/Users/admin/Documents/GitHub/MQP-ZHAW/model_tester.py",
                                 "--adapter_activation", args[0],
                                 " --adapter_initialization", args[1],
                                 "--adapter_layers", args[2]], stdout=subprocess.PIPE)
    elif len(args) == 4:
        proc = subprocess.Popen(["python3", "/Users/admin/Documents/GitHub/MQP-ZHAW/model_tester.py",
                                 "--adapter_activation", args[0],
                                 " --adapter_initialization", args[1],
                                 "--adapter_layers", args[2], args[3]], stdout=subprocess.PIPE)
    elif len(args) == 5:
        proc = subprocess.Popen(["python3", "/Users/admin/Documents/GitHub/MQP-ZHAW/model_tester.py",
                                 "--adapter_activation", args[0],
                                 " --adapter_initialization", args[1],
                                 "--adapter_layers", args[2], args[3], args[4]], stdout=subprocess.PIPE)

    running_processes.append(proc)


